/************************************************/
/* VA͂ꂽXebv[^P	*/
/* ]vOłB			*/
/* 9600bpsŃ^[~i\tgƒʐMĂ	*/
/*						*/
/* <<Stepping Motor Controler>>			*/
/* ƕ\					*/
/*						*/
/* step=					*/
/* Xebv̓͑҂ɂȂ܂		*/
/*						*/
/* Xebvp1.8x̃[^gpꍇ	*/
/* 200Ɠ͂ƂP]܂B		*/
/* 						*/
/************************************************/
/* CN[h					*/
/************************************************/

#include "3664f.h"
#include "machine.h"
#include "step.h"

/************************************************/
/* vg^Cv錾				*/
/************************************************/

extern void reset( void );

void main( void );
void wait( int msec );

void sci_init( void );
void sci_write( unsigned char data );
unsigned char sci_read( void );
void sci_print( char *data );
void sci_reg_print( unsigned long data );
int input_sci( int *data );

/************************************************/
/* 					*/
/************************************************/

void reset( void )
#pragma asm
	mov.l		#H'FF80,ER7	;X^bN|C^
#pragma endasm
{
	set_imask_ccr( 0 );
	_INITSCT();
	main();
	sleep();
}

/************************************************/
/* C					*/
/************************************************/
void main( void )
{
	int step_value;


	step_init();
	sci_init();

	sci_print("\n\n<<Stepping Motor Controler>>\n\n");

	wait(1000);
	while(1){
		sci_print("\nstep=");
		switch( input_sci(&step_value) ){			/*VAXebv*/
			case 0:
				step( step_value, 3.0, 1 );		/*XebvAb]A`l*/
				step_wait( 1 );				/*]I܂ő҂*/
				break;
			case 1:
				break;
			case 2:
				sci_print("\n****** buffer overflow ******\n");
				break;
			case 3:
				sci_print("\n****** invalid parameter ******\n");
				break;
			default:
				break;
		}
	}

}


/************************************************/
/* VAĺ{XXX`|XXX		*/
/************************************************/
int input_sci( int *data )
{
	int i;
	unsigned char a[5];

	i = 0;
	while( i < 5 ){
		a[i] = sci_read();


		if( a[i] == 0x0d || a[i] == 0x0a ){
			sci_write(0x0a);
			sci_write(0x0d);
			break;
		}
		if( a[i] == 0x08 ){
			if( i > 0 ){
				i--;
				sci_write( 0x08 );
				sci_write( 0x20 );
				sci_write( 0x08 );
			}
			continue;
		}

		sci_write( a[i] );
		i++;

	}
	if( i == 5 ){
		return(2);		/*obt@I[o[*/
	}
	if( i == 0 ){
		return(1);		/*f[^Ȃ*/
	}


	if( a[0] == '-' ){		/*擪}CiXH*/
		i = 0;
		*data = 0;
		while( a[i+1] != 0x0d && a[i+1] != 0x0a ){
			if( '0' <= a[i+1] && a[i+1] <= '9' ){		/*R[hȂ*/
				*data = *data * 10 - ( a[i+1] - '0' );		/*͂ꂽ𐔎ɕϊ*/
				i++;
			}else{
				return( 3 );			/*ȊÕf[^͂Ă*/
			}
		}
	}else{
		i = 0;
		*data = 0;
		while( a[i] != 0x0d && a[i] != 0x0a ){
			if( '0' <= a[i] && a[i] <= '9' ){		/*R[hȂ*/
				*data = *data * 10 + ( a[i] - '0' );		/*͂ꂽ𐔎ɕϊ*/
				i++;
			}else{
				return( 3 );			/*ȊÕf[^͂Ă*/
			}
		}
	}

	if( i > 3 ){
		return( 3 );		/*lR𒴂Ă*/
	}

	return( 0 );			/*I*/
}



/************************************************/
/* ^C}[					*/
/************************************************/
void wait( int msec )
{
	long i;
	for( i=0; i<1000 * ( long )msec; i++ ){
	}
}





/************************************************/
/* rbh					*/
/************************************************/
void sci_init( void )
{

	*SCR3 = 0x00;
	*SMR = 0x00;
	*BRR = 0x2f;			/*9600bps 14.7456MHz*/

	wait( 1 );

	*SCR3 = 0x30;			/*M*/
	*PMR1 = 0x0e;			/*tONA*/
}



/************************************************/
/* PoCgVAo				*/
/************************************************/
void sci_write( unsigned char data )
{
	while( !( *SSR & 0x80 ) ){
	}						/* TDRE׸ނPɂȂ܂wait */
	*TDR = data;					/* Mް */
	while( !( *SSR & 0x04 ) ){
	}						/* TEND׸ނPɂȂ܂wait */
}



/************************************************/
/* PoCgVA				*/
/************************************************/
unsigned char sci_read( void )
{
	unsigned char code;

	while( !( *SSR & 0x78 ) ){
	}
	code = *RDR;
	*SSR = *SSR & ~0x78;

	return( code );
}



/************************************************/
/* VAo				*/
/************************************************/
void sci_print( char *data )
{
	while( *data != '\0' ){
		if( *data == '\n' ){
			sci_write(0x0a);
			sci_write(0x0d);
		}else{
			sci_write( *data );
		}

		data++;
	}

}


/************************************************/
/* O[hgdwo			*/
/************************************************/
void sci_reg_print( unsigned long data )
{
	const unsigned char disp_table[] = "0123456789ABCDEF";

	sci_write( disp_table[ ( data & 0xf0000000 ) >> 28 ] );
	sci_write( disp_table[ ( data & 0xf000000 ) >> 24 ] );
	sci_write( disp_table[ ( data & 0xf00000 ) >> 20 ] );
	sci_write( disp_table[ ( data & 0xf0000 ) >> 16 ] );
	sci_write( disp_table[ ( data & 0xf000 ) >> 12 ] );
	sci_write( disp_table[ ( data & 0xf00 ) >> 8 ] );
	sci_write( disp_table[ ( data & 0xf0 ) >> 4 ] );
	sci_write( disp_table[ ( data & 0xf ) ] );
}